# Copies text from file, stripping new lines and certain characters.
def GetLines(FileName):
    file=open(FileName, "rt")
    lines=file.readlines()
    file.close()    
    lines=[line.rstrip("\n") for line in lines]    
    return lines

def StripPunct(line):
    # Ugly, but works.
    line=line.replace(".", "")
    line=line.replace(",", "")
    line=line.replace("!", "")
    line=line.replace("?", "")
    line=line.replace(":", "")
    line=line.replace("(", "")
    line=line.replace(")", "")
    return line

# Removes all numerical escape codes from line (e.g. "\012304".)
def StripCodes(line):
    escape=False
    strippedline=""    
    for character in line:
        if escape == False:
            if character == "\\":
                escape=True
            else:
                strippedline+=character
        else:
            if character not in set("0123456789"):
                if character ==  "\\":
                    escape=True
                else:
                    escape=False
                    strippedline+=character
    return strippedline

# Calculates number of bytes saved by tokenising a string.
def CompressionSaving(token):
    saving = len(token)-1
    for offset in range(len(token)-1):
        stringpair=token[offset:offset+2]
        # Adjust for "lowercase then space" pairs.
        if ord(stringpair[0]) in range(96, 128):
            if stringpair[1] == " ":
                saving-=1
    return saving

# Substitutes all "lowercase then space" pairs for corresponding code.
def SpacePairToEsc(line):
    # N.B. code zero (96-96) is reserved to indicate a gVar reference.
    for asciiCode in range(97, 128):
        word=chr(asciiCode)+" "
        code="\\" + str(asciiCode-96) + "\\"
        line=line.replace(word, code)
    return line

# Adds encoded leading zero byte to variable references within a line.
def EncodeVarRefs(line):
    varRef=False
    varNum=""
    encodedline=""    
    for character in line:
        if varRef == False:
            if character == "\\":
                varRef=True
            else:
                encodedline+=character
        else:
            if character == "\\":
                varRef = False
                if len(varNum)>0:
                    # Character was escape terminator.
                    # Add global variable escape code.
                    encodedline+="\\"+"0"+"\\"
                    # Add variable number.
                    encodedline+="\\"+varNum+"\\"
                    varNum=""
                else:
                    # Character was "\" literal.
                    encodedline+=character                   
            else:
                varNum+=character
    return encodedline 
