import sys

def EscToInt(escString):
    intOut = int(escString)    
    if intOut > 255:
        print("Error: escape code", intOut, "exceeds maximum of 255.")
        sys.exit(1)
    return intOut

def LineToBytes(line):
    bytesOut=bytearray()
    escString=""
    escMode=False
    for char in line:
        if escMode == False:
            if char == "\\":
                escMode = True
            else:
                bytesOut.append(ord(char))
        else:
            if char == "\\":
                escMode = False
                if len(escString)>0:
                    # Character was escape terminator.
                    bytesOut.append(EscToInt(escString))
                    escString = ""
                else:
                    # Character was "\" literal.
                    bytesOut.append(ord(char))                    
            else:
                escString += char  
    return bytesOut

def BytesToLine(bytesIn, lineNum=None):
    line = ""
    ByteCount = 0
    QuoteOpen = True
    LastByte = None
    # Generate string.
    for byte in bytesIn:
        bInt=int(byte)
        ByteCount+=1
        if bInt in range(32,128) and LastByte!=0:
            # ASCII character.
            if QuoteOpen == False:
                line+='"'
                QuoteOpen=True
            # Double any backslash so that...
            # ...Pasmo Z80 compiler interprets them correctly.
            if bInt == 92:
                line+=chr(bInt)
            line+=chr(bInt)
        else:
            if QuoteOpen:
                line+='", '
                QuoteOpen=False            
            line+=str(bInt)
            if ByteCount < len(bytesIn):
                line+=", "
        LastByte=bInt
    if QuoteOpen:
        line+='"'    
    line='  DB "' + line + ' ;' + str(lineNum) + "\n"    
    return line
